/*
 * PM - 2017
 * Proiect 
 * X si O pe led-uri bicolore
 * Carina Mogos 334CC
 */

#define F_CPU 16000000

#include <avr/io.h>
#include <util/delay.h>

#define WIN 10 
#define LOSS -10
#define DRAW 0

#define PLAYER 1
#define BOT 2

#define DELAY_LIGHT 1000

int matrix[3][3];
int row, column; // bot positions

void clear(void) {
	PORTC &= ~(1 << PC5);
	PORTC &= ~(1 << PC6);

	PORTA &= ~(1 << PA0);
	PORTA &= ~(1 << PA1);

	PORTA &= ~(1 << PA0);
	PORTA &= ~(1 << PA1);
	PORTA &= ~(1 << PA2);
	PORTA &= ~(1 << PA3);
	PORTA &= ~(1 << PA4);
	PORTA &= ~(1 << PA5);
	PORTA &= ~(1 << PA6);
	PORTA &= ~(1 << PA7);


	PORTB &= ~(1 << PB0);
	PORTB &= ~(1 << PB1);
	PORTB &= ~(1 << PB2);
	PORTB &= ~(1 << PB3);
	PORTB &= ~(1 << PB4);
	PORTB &= ~(1 << PB5);
	PORTB &= ~(1 << PB6);
	PORTB &= ~(1 << PB7);


}

void light_winner_red(int winning_combo) {
	clear();
	switch(winning_combo){

		case 1:
			while(1){
				PORTA |= (1 << PA0);
				PORTB |= (1 << PB2);
				PORTB |= (1 << PB5);
				_delay_ms(DELAY_LIGHT);
				PORTA &= ~(1 << PA0);
				PORTB &= ~(1 << PB2);
				PORTB &= ~(1 << PB5);

			}
			

		case 2:
			while(1){
				PORTA |= (1 << PA2);
				PORTB |= (1 << PB0);
				PORTB |= (1 << PB7);
				_delay_ms(DELAY_LIGHT);
				PORTA &= ~(1 << PA2);
				PORTB &= ~(1 << PB0);
				PORTB &= ~(1 << PB7);
			}

		case 3:
			while(1){
				PORTA |= (1 << PA4);
				PORTA |= (1 << PA6);
				PORTC |= (1 << PC5);
				_delay_ms(DELAY_LIGHT);
				PORTA &= ~(1 << PA4);
				PORTA &= ~(1 << PA6);
				PORTC &= ~(1 << PC5);
			}
			

		case 4:
			while(1){
				PORTA |= (1 << PA0);
				PORTA |= (1 << PA2);
				PORTA |= (1 << PA4);
				_delay_ms(DELAY_LIGHT);
				PORTA &= ~(1 << PA0);
				PORTA &= ~(1 << PA2);
				PORTA &= ~(1 << PA4);
			}


		case 5:
			while(1){
				PORTB |= (1 << PB2);
				PORTB |= (1 << PB0);
				PORTA |= (1 << PA6);
				_delay_ms(DELAY_LIGHT);
				PORTB &= ~(1 << PB2);
				PORTB &= ~(1 << PB0);
				PORTA &= ~(1 << PA6);

			}
			

		case 6:
			while(1){
				PORTB |= (1 << PB5);
				PORTB |= (1 << PB7);
				PORTC |= (1 << PC5);
				_delay_ms(DELAY_LIGHT);
				PORTB &= ~(1 << PB5);
				PORTB &= ~(1 << PB7);
				PORTC &= ~(1 << PC5);
			}

		case 7:
			while(1){
				PORTA |= (1 << PA0);
				PORTB |= (1 << PB0);
				PORTC |= (1 << PC5);
				_delay_ms(DELAY_LIGHT);
				PORTA &= ~(1 << PA0);
				PORTB &= ~(1 << PB0);
				PORTC &= ~(1 << PC5);
			}
			

		case 8:
			while(1){
				PORTA |= ~(1 << PA4);
				PORTB |= ~(1 << PB0);
				PORTB |= ~(1 << PB5);
				_delay_ms(DELAY_LIGHT);
				PORTA &= ~(1 << PA4);
				PORTB &= ~(1 << PB0);
				PORTB &= ~(1 << PB5);
			}
	
	}	

}

void light_winner_green(int winning_combo) {
	clear();

	switch(winning_combo){

		case 1:	
			while(1) {
				PORTA |= (1 << PA1);
				PORTB |= (1 << PB3);
				PORTB |= (1 << PB4);
				_delay_ms(DELAY_LIGHT);
				PORTA &= ~(1 << PA1);
				PORTB &= ~(1 << PB3);
				PORTB &= ~(1 << PB4);
			}
			

		case 2:
			while(1) {
				PORTA |= (1 << PA3);
				PORTB |= (1 << PB1);
				PORTB |= (1 << PB6);
				_delay_ms(DELAY_LIGHT);
				PORTA &= ~(1 << PA3);
				PORTB &= ~(1 << PB1);
				PORTB &= ~(1 << PB6);
			}
			

		case 3:
			while(1) {
				PORTA |= (1 << PA5);
				PORTA |= (1 << PA7);
				PORTC |= (1 << PC6);
				_delay_ms(DELAY_LIGHT);
				PORTA &= ~(1 << PA5);
				PORTA &= ~(1 << PA7);
				PORTC &= ~(1 << PC6);
			}
			

		case 4:
			while(1) {
				PORTA |= (1 << PA1);
				PORTA |= (1 << PA3);
				PORTA |= (1 << PA5);
				_delay_ms(DELAY_LIGHT);
				PORTA &= ~(1 << PA1);
				PORTA &= ~(1 << PA3);
				PORTA &= ~(1 << PA5);
			}

		case 5:
			while(1) {				
				PORTB |= (1 << PB3);
				PORTB |= (1 << PB1);
				PORTA |= (1 << PA7);
				_delay_ms(DELAY_LIGHT);
				PORTB &= ~(1 << PB3);
				PORTB &= ~(1 << PB1);
				PORTA &= ~(1 << PA7);
			}

		case 6:
			while(1){
				PORTB |= (1 << PB4);
				PORTB |= (1 << PB6);
				PORTC |= (1 << PC6);
				_delay_ms(DELAY_LIGHT);
				PORTB &= ~(1 << PB4);
				PORTB &= ~(1 << PB6);
				PORTC &= ~(1 << PC6);
			}
			
		case 7:
			while(1){
				PORTA |= (1 << PA1);
				PORTB |= (1 << PB1);
				PORTC |= (1 << PC6);
				_delay_ms(DELAY_LIGHT);
				PORTA &= ~(1 << PA1);
				PORTB &= ~(1 << PB1);
				PORTC &= ~(1 << PC6);
			}


		case 8:
			while(1){
				PORTA |= (1 << PA5);
				PORTB |= (1 << PB1);
				PORTB |= (1 << PB4);
				_delay_ms(DELAY_LIGHT);
				PORTA &= ~(1 << PA5);
				PORTB &= ~(1 << PB1);
				PORTB &= ~(1 << PB4);
			}
		}
}

int check_winner(int player) {
	// linii
	if((matrix[0][0] == matrix[0][1]) && (matrix[0][0] == matrix[0][2]) && (matrix[0][0] == player)) return 1;
	if((matrix[1][0] == matrix[1][1]) && (matrix[1][0] == matrix[1][2]) && (matrix[1][0] == player)) return 2;
	if((matrix[2][0] == matrix[2][1]) && (matrix[2][0] == matrix[2][2]) && (matrix[2][0] == player)) return 3;

	// coloane
	if((matrix[0][0] == matrix[1][0]) && (matrix[0][0] == matrix[2][0]) && (matrix[0][0] == player)) return 4;
	if((matrix[0][1] == matrix[1][1]) && (matrix[0][1] == matrix[2][1]) && (matrix[0][1] == player)) return 5;
	if((matrix[0][2] == matrix[1][2]) && (matrix[0][2] == matrix[2][2]) && (matrix[0][2] == player)) return 6;

	// diag principala
	if((matrix[0][0] == matrix[1][1]) && (matrix[0][0] == matrix[2][2]) && (matrix[0][0] == player)) return 7;

	// diag secundara
	if((matrix[0][2] == matrix[1][1]) && (matrix[2][0] == matrix[1][1]) && (matrix[0][2] == player)) return 8;

	return 0;
}

void green_led() {

		if(matrix[0][0] == PLAYER) {
			PORTA |= (1 << PA1);
		}
		if(matrix[0][1] == PLAYER) {
			PORTB |= (1 << PB3);
		}
		if(matrix[0][2] == PLAYER) {
			PORTB |= (1 << PB4);
		}
		if(matrix[1][0] == PLAYER) {
			PORTA |= (1 << PA3);
		}
		if(matrix[1][1] == PLAYER) {
			PORTB |= (1 << PB1);
		}
		if(matrix[1][2] == PLAYER) {
			PORTB |= (1 << PB6);
		}
		if(matrix[2][0] == PLAYER) {
			PORTA |= (1 << PA5);
		}
		if(matrix[2][1] == PLAYER) {
			PORTA |= (1 << PA7);
		}
		if(matrix[2][2] == PLAYER) {
			PORTC |= (1 << PC6);
		}
}

void red_led() {

		if(matrix[0][0] == BOT) {
			PORTA |= (1 << PA0);
		}
		if(matrix[0][1] == BOT) {
			PORTB |= (1 << PB2);
		}
		if(matrix[0][2] == BOT) {
			PORTB |= (1 << PB5);
		}
		if(matrix[1][0] == BOT) {
			PORTA |= (1 << PA2);
		}
		if(matrix[1][1] == BOT) {
			PORTB |= (1 << PB0);
		}
		if(matrix[1][2] == BOT) {
			PORTB |= (1 << PB7);
		}
		if(matrix[2][0] == BOT) {
			PORTA |= (1 << PA4);
		}
		if(matrix[2][1] == BOT) {
			PORTA |= (1 << PA6);
		}
		if(matrix[2][2] == BOT) {
			PORTC |= (1 << PC5);
		}
}

int otherplayer(int player) {
	if(player == BOT)
		return PLAYER;
	return BOT;
}

int minimax(int occ, int depth, int player){

	int score, max = LOSS;
	int i, j;

	if(check_winner(2) != 0) return WIN * (10 - depth);
	if(check_winner(1) != 0) return LOSS * (10 - depth);

	if(occ >= 9) return DRAW;

	for(i = 0; i < 3; i++)
		for(j = 0; j < 3; j++){
			if(matrix[i][j] == 0){
				matrix[i][j] = player;
				score = -minimax(occ + 1, depth + 1, otherplayer(player));
				matrix[i][j] = 0;

				if(score > max){
					max = score;
					row = i;
					column = j;
				}
			}
		}

	return max;
}

void bot_move(void) {
	minimax(0, 0, BOT);
	matrix[row][column] = BOT;
}

void init(void) {
	int i, j; 

	for(i = 0; i < 3; i++)
		for(j = 0; j < 3; j++)
			matrix[i][j] = 0;

	/* Butoane */
	DDRD &= ~((1 << PD0) | (1 << PD1) | (1 << PD3) | (1 << PD5) | (1 << PD6));
	DDRC &= ~((1 << PC0) | (1 << PC1) | (1 << PC2) | (1 << PC3) | (1 << PC4));


	/* Activez rezistenta de pull-up pentru pinul PB0. */
	PORTD |= (1 << PD0) | (1 << PD1) | (1 << PD3) | (1 << PD5) | (1 << PD6);
	PORTC |= (1 << PC0) | (1 << PC1) | (1 << PC2) | (1 << PC3) | (1 << PC4);

	/* Setez pinul PC0 ca iesire. */
	DDRB |= (1 << PB0) | (1 << PB1) | (1 << PB2) | (1 << PB3)| (1 << PB4) | (1 << PB5) | (1 << PB6) | (1 << PB7);
	DDRA |= (1 << PA0) | (1 << PA1) | (1 << PA2) | (1 << PA3)| (1 << PA4) | (1 << PA5) | (1 << PA6) | (1 << PA7);
	DDRC |= (1 << PC5) | (1 << PC6);
}


void game(void) {
	int ok = 0;

	while (1) {
		/* Daca butonul este apasat, aprind led-ul verde*/
		
		if ((PIND & (1 << PD6)) == 0 && matrix[0][2] == 0){
			matrix[0][2] = PLAYER;
			ok = 1;
		}
		if ((PIND & (1 << PD5)) == 0 && matrix[0][1] == 0){
			matrix[0][1] = PLAYER;
			ok = 1;
		}
		if ((PIND & (1 << PD1)) == 0 && matrix[0][0] == 0){
			matrix[0][0] = PLAYER;
			ok = 1;
		}
		if ((PIND & (1 << PD0)) == 0 && matrix[1][2] == 0){
			matrix[1][2] = PLAYER;
			ok = 1;
		}
		if ((PINC & (1 << PC0)) == 0 && matrix[1][1] == 0){
			matrix[1][1] = PLAYER;
			ok = 1;
		}
		if ((PINC & (1 << PC1)) == 0 && matrix[1][0] == 0){
			matrix[1][0] = PLAYER;
			ok = 1;
		}
		if ((PINC & (1 << PC2)) == 0 && matrix[2][2] == 0){
			matrix[2][2] = PLAYER;
			ok = 1;
		}
		if ((PINC & (1 << PC3)) == 0 && matrix[2][1] == 0){
			matrix[2][1] = PLAYER;
			ok = 1;
		}
		if ((PINC & (1 << PC4)) == 0 && matrix[2][0] == 0){
			matrix[2][0] = PLAYER;
			ok = 1;
		}

		if(ok == 1){
			green_led();
			bot_move();
			red_led();

			if(check_winner(PLAYER))
				light_winner_green(check_winner(PLAYER));
			if(check_winner(BOT))
				light_winner_red(check_winner(BOT));
		}
		
		ok = 0;

	}
}


int main(void) {

	init();
	game();

	return 0;
}
